#! /usr/bin/env python
#-*- coding: utf-8 -*-
__version__="20150409-14"
import sys
import serial
import string
import os
from datetime import datetime
import time
from lscLib import ftpName, adler, pLogg,cPaths,pLog,variableLoad
import RPi.GPIO as GPIO
"""
20140409
Zmaina portów, poprawianie liczenia.
wejście pin18
led czerwony pin12
20150403 - początek projektu lscGpio
liczenie na porcie Rpi.

sudo ./lscGpio.py 1837 /opt/zeletronik 8 2 0.5 1.0 0

/opt/zeletronik/bin/lscGpio.py 1837       /opt/zeletronik 8        0     1.0       1.0         1

/opt/zeletronik/bin/lscGpio.py namePrefix /opt/zeletronik logLevel gpio  activeTime passiveTime activeSlope
A0-----------------------------A1---------A2--------------A3-------A4--_-A5---------A6----------A7

Jeżeli poziom wysoki, led czerwony miga, jeżeli nie było zliczenia (block==0)
Warunek zliczenia - dostateczny odstęp zliczeń (block)
Dostatecznie długi impuls (signal)
Dostatecznie długa przerwa przed impulsem (gapState)
gapState odlicza się podczas stanu niskiego do gapTime, ustawia się na początku stanu niskiego,
podczas stnu wysokiego bez zmian.
Led zapala sie tylko jeżeli blok>0
jeżeli była dostatecznie duża przerwa 
"""



aL=True#activeLevel
def hiOut(no):
    GPIO.output(no, GPIO.HIGH)
def lowOut(no):
    GPIO.output(no, GPIO.LOW)
def setOut(no,Level):
    if Level:
        GPIO.output(no, GPIO.HIGH)
    else:
        GPIO.output(no, GPIO.LOW)





def testIn(no,activeLevel):
    #activeLevel True,False (Hi/Low) 
    if (GPIO.input(no) == True and activeLevel==1) or (GPIO.input(no) == False and  activeLevel==0):
        return True
    else:
        return False


#start#####################################################
now = datetime.now()
timestamp=now.strftime("%Y%m%d %H:%M ")
pts=cPaths(sys.argv)
namePrefix = pts.namePrefix
countersPath = pts.firmName
number=0
foEr='F'#błąd fotokomórki
#------------------fukcja debugera
#loggName = os.path.join(countersPath,namePrefix,'log',namePrefix+'_lscIn.log')
logName = pts.logName

try:
    flogg=open(logName, 'ab')
except:
    sys.exit("can't open file %s" % logName)
#print "-->",logName
logLevel=pts.logLevel
vl=(flogg,logLevel,timestamp,__version__)    
timeOld="20000101 01:01"

gpio=int(sys.argv[4])
activeTime=float(sys.argv[5])
passiveTime=float(sys.argv[6])
aL=int(sys.argv[7]) #activeLevel
pLog(vl,6,"-----------------START------------------------")
pLogg(vl,6,"GPIO nr=%d activeTime=%f passiveTime=%f activeSlope= %d logLevel=%d" % \
      (gpio,activeTime, passiveTime,aL,logLevel))

inNo=[18,16,18] #wejście
outNo=[11,13,12] #led sygnalizacyjny
inC=inNo[gpio]
outC=outNo[gpio]
#print inC, outC
GPIO.setmode(GPIO.BOARD)
GPIO.setup(inC, GPIO.IN)
GPIO.setup(outC, GPIO.OUT)
GPIO.output(outC, GPIO.HIGH)
GPIO.setup(16, GPIO.OUT)#zielony led
GPIO.output(16, GPIO.HIGH)#led zapal
timeStep=0.01
blockTime=int(passiveTime/timeStep)
signalOn=int(activeTime/timeStep)
gapTime=signalOn
gapState=gapTime
#print signalOn, blockTime
state=False#ostatni stan
block=blockTime # czas  blokowania po zliczeniu
lamp=0#sterowanie miganiem leda
signal=0 #czas wysokiego wejścia potrzebny do zliczenia


while True:
    if timestamp!=timeOld:
        ##############----------start minuty
        timeOld=timestamp
        #print timestamp

        #loggLevel= 8

        pLog(vl,0, 'start------------------')
        #sprawdzenie liczby argumentów
        pLog(vl,3,"Ilosc argumentow wywolania %d" % len(sys.argv))
        #-------------tworzenie nazwy i sciezki pliku txt
        nowDateTime="%4d%02d%02d_%02d%02d" %(now.year,now.month,now.day,now.hour,now.minute)
        repName="%s_%s.txt" %(namePrefix, nowDateTime)
        pLogg(vl,5,"repName = %s" % repName) 
        repPath=os.path.join(pts.repDir,'minutes',repName)
        pLogg(vl,5,"repPath = %s" % repPath)
        #-----------------otwieranie pliku rep
        try:
            repF=open(repPath, 'wb')
        except:
            pLogg(vl,0,"Nie mozna otworzyc %s do zapisu" % repPath)
            flogg.close()
            sys.exit("can't open file %s" % repPath)          

                 
        rekordA='%06d;%s' % (number,foEr)
        pLogg(vl,5,"Odczyt licznika = %s" % rekordA)
        number=0

        rekord=rekordA+';'+adler(rekordA)+';'
        repF.write(rekord)
        pLogg(vl,4,rekord)            
        #------------------lista plikow do sklejania

        repF.close()
        pLogg(vl,0,"stop||||||||||||||||||||||||||||")
        foEr='F'#błąd fotokomórki

    #else:
    time.sleep(timeStep)
    

    if testIn(inC,aL):#wejście wysokie
        
        if block==0:#liczenie tylko po zakończeniu blokowania
            if lamp >0:#miganie ledem, jeżeli stan aktywny, po zakończeniu blokowania
                lamp-=1
                #hiOut(outC)#led zgaszony
                lowOut(outC)#led zgaszony
                
            else:
                lamp=6
                #lowOut(outC) #led zapalony
                hiOut(outC) #led zapalony
            if gapState==0:
                if signal<signalOn:                

                    signal+=1
                else:
                    #print "pressed B1 "
                    number+=1
                    #lowOut(outC)
                    hiOut(outC) #led zapalonylow
                    #gapState=gapTime
                    gapState=gapTime
                    block=blockTime
                    signal=0                
        state=True
    else:#wejście niskie
        #GPIO.output(13, GPIO.HIGH)
        if state:
            
            state=False
            if signal==0 and gapState==0:
                gapState=gapTime
        lamp=6
        if gapState>0:
            gapState-=1
        if signal>0:
            signal-=1
        if block==0 :
            lowOut(outC)#led zgaszony
            #signal=0
            foEr=' '#błąd fotokomórki
            
    if block>0:
            block-=1#czas bloku odliczany niezależnie od wejścia
            #lowOut(outC) #led zapalony
            hiOut(outC) #led zapalony

    #time.sleep(5)
    now = datetime.now()
    timestamp=now.strftime("%Y%m%d %H:%M ")
    if logLevel>8:
        print GPIO.input(inC),testIn(inC,aL),signal,gapState, block,number
    
flogg.close()
#tn.close()

