#! /usr/bin/env python
# -*- coding: utf-8 -*-

import shutil
import string
import filecmp
import ftplib
import socket
from datetime import datetime
from lscLib import pLog,confFileDict,copyFileL,cPaths
import sys
import os
import pickle

__version__ = '20150414-3'

'''
'20150414-1'
Usunięcie delTime z argumentów
'20150410-1'
uniwersalna wersja dla zip i csv
Ponieważ pliki są wysyłane, trash jest do naprawdę chwilowego przechowywania.
musi dostać wszysko w argumentach, pliki sobie wylistuje jak lscGlue
command=os.path.join(binPath,'lscToFtp.py')

2. firmName katalog w którym są katalogi liczników, np /opt/zeletronik
3. interwal wysyłania w minutach
4. końcówka katalogu w którym są pliki do wysłania
5. adres serwera
6. login

#cmd=['python',0command,1namePrefix, 2firmName,3interval,4localDir,
5url, 6login 7passwd 8ftpDir 9logLevel  10timeOut 11delTime]
#/opt/zeletronik/bin/lscToFtp2.py rs232 /opt/zeletronik/ 2 dat 192.168.1.66 pico tajne 65rs232/dat 8 5 100
les@c2014:/opt/zeletronik/bin$
sudo /opt/zeletronik/bin/lscToFtp2.py rs232 /opt/zeletronik/ 2 zip 192.168.1.66 pico tajne 65rs232/dat 8 5 100


141001-3
sprawdzanie pliku od razu po wysłaniu.
wysyłanie plików tekstowych na txt na serwer ftp
20121106 0.2.11
przerzucanie wysłanych plików do trash
lscToFtp.py 1.localEndDir 2.url 3.ftpDir 4.login
5.passwd  6.logLevel 7.delTime 8.timeOut


lscToFtp.py lscNewZip ftp.letronik.nazwa.pl letronikMain letronik_ec passwd 6 60 5

20121002
0.2.10
dodanie kompresji i szyfrowania.

20120927 0.2.04
wstawienie txtFtpOn


'''

#aktualizacja daty  
now = datetime.now()
dayMinute = int(now.strftime("%H"))*60 +int(now.strftime("%M"))
timestamp=now.strftime("%Y%m%d %H:%M ")
print 'start - ',timestamp



#cmd=['python',0command,1namePrefix, 2firmName,3interval,4localDir,5url,6ftpDir 7login 8passwd  9logLevel  10timeOut]
#--------------wyciąganie prefixu nazwy uruchomienia ------------------------------
if len(sys.argv)==11:#jeżeli wersja serwerowa
    pts = cPaths(sys.argv)
    namePrefix = pts.namePrefix
    cDir=pts.cDir
    outDir=os.path.join(cDir,'ftpDat')
    ramDir=os.path.join(cDir,'ramdisk')

    
    
    #ftpDir - dla firmy np: letronik
    logName=os.path.join(pts.logDir,'%s_Ftp2.log' % namePrefix)
    confDir=pts.confDir
    configName=os.path.join(confDir,'%s_lsc.conf' % namePrefix)
else:
    sys.exit("Too few arguments")
    









#cmd=['python',0command,1namePrefix/counterDir, 2firmName,3interval,4localDir,5url, 6login 7passwd 8ftpDir 9logLevel  10timeOut ]
#lscToFtp2.py rs232 /opt/zeletronik/
interval = int(sys.argv[3])
localEndDir = sys.argv[4]
hostName = sys.argv[5]
userName = sys.argv[6]
ftpPass = sys.argv[7]
ftpDir = sys.argv[8]
logLevel = int(sys.argv[9])
timeOut = int(sys.argv[10])
localDir=os.path.join(cDir,'reports',localEndDir)
trashDir=os.path.join(cDir,'trash',localEndDir)


     
        
############## I generates the configuration dictionary /Generuję słownik kofiguracji /
clNews='start - '


try:
     flog=open(logName, 'ab')
except:
     sys.exit("can't open file %s" % logName)
     
vl=(flog,logLevel,timestamp,__version__)
pLog(vl,3,"-----------Start przetwarzania logLevel=%s------------" % logLevel)
pLog(vl,3,clNews)






#sprawdzanie, czy wysyłać

if(dayMinute % int(interval)):
    pLog(vl,5, "do transmisji - %d minut" % (int(interval)-(dayMinute % int(interval))))
    flog.close()              
    sys.exit("do transmisji - %d minut" % (int(interval)-(dayMinute % int(interval))))#wewnętrzny cron



pLog(vl,6, 'hostName=%s ftpPath=%s  userName=%s  ftpPas=%s' % (hostName,ftpDir,userName,'tajne'))
pLog(vl,6, 'logLevel=%d timeOut=%d-sec' % (logLevel, timeOut))

pLog(vl,6, 'localDir=%s '  % (localDir))

#listowanie plików do wysłania
fileToSendList=[]
newFile=os.listdir(localDir)
if len(newFile)==0:
    pLog(vl,6,'Brak plików do sklejania')
    flog.close()
    sys.exit(0)    
newFile.sort()
for txtx in newFile:
    newItem=(os.path.join(localDir,txtx))
    fileToSendList.append(newItem)
    pLog(vl,6,newItem)

komunikat = '\nIlosc plikow do wyslania = '+str(len(fileToSendList))
pLog(vl,3,komunikat)#zapisywanie do logu
#fo = open(tmpList, 'wb')
if len(fileToSendList)>0:
     #aktualizacja daty  
    now = datetime.now()


    ftpdane = '\nhostName='+hostName+'\nuserName='+userName+'\nftpPass=' \
               +'tajne'+'\nftpPath='+ftpDir+'\ntimeOut'+str(timeOut)+'\nlogLevel'+str(logLevel)

    pLog(vl,3, ftpdane)
    
    if timeOut!=0:

        try:
            ftp = ftplib.FTP()
            ftp.connect(hostName,21,timeOut)
        except (socket.error, socket.gaierror), e:
            pLog(vl,2, 'ERROR: cannot reach "%s"' % hostName)
            flog.close()
            sys.exit(1)
        pLog(vl,5, '*** Connected to host "%s"' % hostName)
#python 2.5 nie obsluguje timeOut        
    else:       
        try:
            ftp = ftplib.FTP()
            ftp.connect(hostName,21)
        except (socket.error, socket.gaierror), e:
            pLog(vl,2, 'ERROR: cannot reach "%s"' % hostName)
            flog.close()
            sys.exit(1)
        pLog(vl,5, '*** Connected to host "%s"' % hostName)    

    try:
        ftp.login(userName,ftpPass)
    except:
        pLog(vl,1, "can't login to FTP")
         

     #log skryptu

     #wykaz brakujacych plilow
    for fileToSend in fileToSendList:#fileToSend - nazwa pliku lokalnego do wysłania
        wyslac = False # jesli True to wyslac i wpisac na liste wysylkowa do przyszlego porownania
        fileToSendPath = fileToSend#string.split(fileToSend,'\n')[0] #odrzucane znaku konca linii
        if os.path.exists(fileToSendPath):#sprawdzanie, czy plik nie usuniety 20130327
        #print fileToSendPath
            urlBase = string.split(fileToSendPath,'/')[-1] #wycinanie nazwy raportu.
            komunikat = '\n Nazwa raportu: '+fileToSendPath
            #plog(vl,5, komunikat)

            ftpAdr = '/'+ ftpDir +'/' + urlBase
            komunikat =komunikat +'\n Nawa pliku na ftp: '+ftpAdr
            ramRep = os.path.join(ramDir,'ftp_%s' % (urlBase))

            #sprawdzamy czy jest plik na ftp sciągając go do ramu
            try:
                xf=open(ramRep, 'wb')
                ftp.retrbinary('RETR '+ftpAdr, xf.write)
                xf.flush()
                xf.close()
            
            #jesli nie ma
            except:
                e = sys.exc_info()[0]
                komunikat = komunikat +'\n błąd %s brak pliku %sna ftp: ' % (e,ftpAdr)
                wyslac =  True

            #jesli jest, to porownamy, czy dobry.      
            else:
                komunikat = komunikat +'\n jest plik na ftp: ' + ftpAdr
                #zapisanie pliku do porównania jako logu, to chyba tylko do diagnostyki
                '''
                if logLevel >= 6:
                    pLog(vl,6,copyFileL(os.path.join(ramDir,'oldRamRep2.csv'),os.path.join(ramDir,'oldRamRep1.csv')))
                    pLog(vl,6,copyFileL(os.path.join(ramDir,'OldUrlPath2.csv'),os.path.join(ramDir,'OldUrlPath1.csv')))
                    pLog(vl,6,copyFileL(ramRep,os.path.join(ramDir,'oldRamRep2.csv')))#remRep - sciągniety z FTP
                    pLog(vl,6,copyFileL(fileToSendPath,os.path.join(ramDir,'OldUrlPath2.csv')))#plik do wysłania'''

                                    
                try:
                    xcomp=filecmp.cmp(fileToSendPath,ramRep,False)
                except:
                    komunikat += '\n Error nie można porownac fileToSendPath = %s ramRep = %s' % (fileToSendPath, ramRep)
                else:
                    #pliki prównane
                    pLog(vl,6,"wynik porównania fileToSendPath,ramRep = %s" % xcomp)    
                    if xcomp:
                        #pliki takie same, plik wyrzucamy do kosza przejściowego
                        
                        komunikat = komunikat +'\npliki identyczne ' + urlBase
                        os.remove(ramRep)
                        try:
                            os.utime(fileToSendPath,None)
                        except :
                            e = sys.exc_info()[0]
                            pLog(vl,3,'błąd =  %s nieudana zmiana daty modyfikacji %s' % (e,fileToSendPath))
                        else:
                            pLog(vl,6,'datę modyfikacji  %s zmieniono' % fileToSendPath)
                            # usuwanie starego pliku w koszu lokalnym, żeby można było wrzucić nową wersję
                            # adres pliku csv w koszu lokalnym

                            trashPath=os.path.join(trashDir, urlBase)
                            try:
                                os.remove(trashPath)
                            except:
                                e = sys.exc_info()[0]
                                pLog(vl,6,'blad = %s czyli nie ma jeszcze w koszu %s' % (e,trashPath))
                            else:
                                pLog(vl,6,'Zrobiono w koszu miejsce na plik %s' % trashPath)
                                
                                
                            try:    
                                shutil.move(fileToSendPath,trashDir)
                            except:
                                e = sys.exc_info()[0]
                                pLog(vl,6,'blad = %s nieudane wyrzucanie %s' % (e,fileToSendPath))
                            else:
                                pLog(vl,6,'plik %s wyrzucono' % fileToSendPath)
                    
                    else:
                        #pliki różne
                        wyslac =  True
                        komunikat = komunikat +'\npliki rożne ' + urlBase
                #else:
                    #wyslac =  False
                 #print 'porownanie sie odbylo'
        if wyslac:
            try:
                flok = open(fileToSendPath, "rb")
            except:
                 komunikat =komunikat + '\nie można otworzyć pliku lokalnego %s' % fileToSendPath
            try:

                ftp.storbinary('STOR '+ftpAdr, flok, 1024)
                #fo.write(fileToSendPath+'\n')#dopisywanie pliku do sprawdzenia następnym razem
                flok.close() 
            except:
                komunikat = komunikat +'\n nie można skopiować pliku lokalnego %s na FTP\n adr = %s' % (fileToSendPath,ftpAdr)
            else:
                komunikat = komunikat +'\n chyba skopiowano plik lokalny %s na FTP\n adr = %s' % (fileToSendPath,ftpAdr)
#---------------porównanie wysłanego pliku  z oryginałem początek



           #sprawdzamy czy jest plik na ftp
                try:
                    xf=open(ramRep, 'wb')
                    ftp.retrbinary('RETR '+ftpAdr, xf.write)
                    xf.flush()
                    xf.close()
                
                #jesli nie ma, dopisujemy z powrotem do listy i wysylamy
                except:
                    e = sys.exc_info()[0]
                    komunikat = komunikat +'\n błąd %s brak pliku %sna ftp: ' % (e,ftpAdr)
                    #wyslac =  True

                #jesli jest, to porownamy, czy dobry.      
                else:
                    komunikat = komunikat +'\n jest plik na ftp: ' + ftpAdr
                    #zapisanie pliku do porównania jako logu, to chyba tylko do diagnostyki
                    '''
                    if logLevel >= 6:
                        pLog(vl,6,copyFileL(os.path.join(ramDir,'oldRamRep2.csv'),os.path.join(ramDir,'oldRamRep1.csv')))
                        pLog(vl,6,copyFileL(os.path.join(ramDir,'OldUrlPath2.csv'),os.path.join(ramDir,'OldUrlPath1.csv')))
                        pLog(vl,6,copyFileL(ramRep,os.path.join(ramDir,'oldRamRep2.csv')))
                        pLog(vl,6,copyFileL(fileToSendPath,os.path.join(ramDir,'OldUrlPath2.csv')))
                        '''

                                        
                    try:
                        xcomp=filecmp.cmp(fileToSendPath,ramRep,False)
                    except:
                        komunikat += '\n Error nie można porownac fileToSendPath = %s ramRep = %s' % (fileToSendPath, ramRep)
                    else:
                        #pliki prównane
                        pLog(vl,6,"wynik porównania fileToSendPath,ramRep = %s" % xcomp)    
                        if xcomp:
                            #pliki takie same
                            
                            komunikat = komunikat +'\npliki identyczne ' + urlBase
                            wyslac = False
                            os.remove(ramRep)
                            try:
                                os.utime(fileToSendPath,None)
                            except :
                                e = sys.exc_info()[0]
                                pLog(vl,3,'błąd =  %s nieudana zmiana daty modyfikacji %s' % (e,fileToSendPath))
                            else:
                                pLog(vl,6,'datę modyfikacji  %s zmieniono' % fileToSendPath)
                                # usuwanie starego pliku w koszu lokalnym, żeby można było wrzucić nową wersję
                                # adres pliku csv w koszu lokalnym

                                trashPath=os.path.join(trashDir, urlBase)
                                try:
                                    os.remove(trashPath)
                                except:
                                    e = sys.exc_info()[0]
                                    pLog(vl,6,'blad = %s czyli nie ma jeszcze w koszu %s' % (e,trashPath))
                                else:
                                    pLog(vl,6,'Zrobiono w koszu miejsce na plik %s' % trashPath)
                                    
                                    
                                try:    
                                    shutil.move(fileToSendPath,trashDir)
                                except:
                                    e = sys.exc_info()[0]
                                    pLog(vl,6,'blad = %s nieudane wyrzucanie %s' % (e,fileToSendPath))
                                else:
                                    pLog(vl,6,'plik %s wyrzucono' % fileToSendPath)
                        
                        else:
                            #pliki różne
                            wyslac =  True
                            komunikat = komunikat +'\npliki rożne ' + urlBase
                
#---------------porównanie wysłanego pliku  z oryginałem koniec
        #if wyslac:
            #fo.write(fileToSendPath+'\n')#dopisywanie pliku do sprawdzenia następnym razem

         #print komunikat      
        pLog(vl,3,komunikat)#zapisywanie do logu


    ftp.quit()
#fo.close()

pLog(vl,3, '****program wykonal sie do konca')
flog.close()
print 'stop - ', datetime.now()-now

