#! /usr/bin/env python
#-*- coding: utf-8 -*-





#import os.path
import shutil
import string
import filecmp


from datetime import datetime, timedelta
import sys
import commands
import os
from lscLib import confDict, pLog, createDir, createLink,\
     str2file, variableLoad, pLog, replaceLine,\
     makeConFile,callCommandArg,confFileDict, yesNo
#sys.exit('1')


'''
instalpvc.py
20140828 - początek projektu.
20140924 - instalowanie kilku liczników.
20141216 - instalowanie mTL.py
20150211 - #katalog /opt/zeletronik/counters
20150402 - lscCtsPy.py
20140415 - wersja dla lpvc
'''
#----------wczytwyanie konfiguracji
#def copyBin(name):
#def copyLib(name):
#def copyConf(source,name):
#def copyFile(source,target):
#------------tworzenie katlogów-------


__version__ = '150416-02'
rootPath='/'
now = datetime.now()
old = now
errNum=0
auto=None
namePrefix=None
logName='./instalpvc.log'
timestamp=now.strftime("%Y%m%d %H:%M ")
try:
     flog=open(logName, 'wb')
except:
     sys.exit("can't open file %s" % logName)
logLevel=9
vl=(flog,logLevel,timestamp,__version__)
pLog(vl,1,"---------start instalacji-------------")

#----------wczytwyanie konfiguracji

configName = os.path.join ('conf','install.conf')
config=confFileDict(configName)
pLog(vl,1,"configuraja odczytana z pliku.conf ")

#katalog, w którym będzie katalog bin
arch = config['arch']
binDir = config['binDir']
confDir = os.path.join(binDir,'../conf')
#--------20141203 czytanie konfiguracji z loklanego pliku.
localConfig=os.path.join(confDir, 'install.conf')
if os.path.exists(localConfig):
     config=confFileDict(localConfig)
     pLog(vl,1,"configuraja odczytana z lokalnego pliku %s " % localConfig)
     
     

#katalog, w którym będą umieszczane katalogt liczników
countDir = config['countDir']
#przedrostek nazwy plików licznika
namePrefixs = config['namePrefixs']
counterList = namePrefixs.split(',')
pLog(vl,1, 'arch = '+ arch)
pLog(vl,1,'binDir = %s, countDir = %s namePrefix = %s' % (binDir,countDir,namePrefixs))
pLog(vl,1, 'counterList' + str(counterList))

'''
flog.close()
sys.exit('1')
'''
#---------Funkcje--------
def copyBin(name):
    '''
Kopiowanie z dodaniem prefixu - zawsze nadpisz.
'''
    global errNum
    srcBin='bin/%s' %(name)
    dstBin=os.path.join(binDir,namePrefix+'_'+name)
    binFile=0
    if os.path.exists(srcBin):
        
        if os.path.exists(dstBin):
            binFile=1
            pLog(vl,1, 'jest  %s, usunę' % dstBin)
            try:
                os.remove(dstBin)
            except:
                pLog(vl,1, 'ERROR - nie udało się skasować %s' % dstBin)
                errNum+=1
                pLog(vl,1, 'ERROR Nr = %d' % errNum)
            else:
                pLog(vl,1, 'skasowałem %s' % dstBin)
                binFile=0
        if binFile==0:
            try:
                 shutil.copy(srcBin,dstBin)
            except:
                pLog(vl,1, 'ERROR -nie udało się skopiować %s' % srcBin)
                errNum+=1
                pLog(vl,1, 'ERROR Nr = %d' % errNum)
            else:
                pLog(vl,1, 'skopiowałem %s' % srcBin)

    else:
        pLog(vl,1, 'ERROR - brak pliku źródłowego %s' % srcBin)
        errNum+=1


def copyLib(name):
    '''
Nadpisywanie
'''
    global errNum
    srcBin='bin/%s' %(name)
    dstBin=os.path.join(binDir,name)
    binFile=0
    if os.path.exists(srcBin):
        
        if os.path.exists(dstBin):
            binFile=1
            pLog(vl,1, 'jest  %s, usunę' % dstBin)
            try:
                os.remove(dstBin)
            except:
                pLog(vl,1, 'ERROR - nie udało się skasować %s' % dstBin)
                errNum+=1
                pLog(vl,1, 'ERROR Nr = %d' % errNum)
            else:
                pLog(vl,1, 'skasowałem %s' % dstBin)
                binFile=0
        if binFile==0:
            try:
                 shutil.copy(srcBin,dstBin)
            except:
                pLog(vl,1, 'ERROR -nie udało się skopiować %s' % srcBin)
                errNum+=1
                pLog(vl,1, 'ERROR Nr = %d' % errNum)
            else:
                pLog(vl,1, 'skopiowałem %s' % srcBin)

    else:
        pLog(vl,1, 'ERROR - brak pliku źródłowego %s' % srcBin)
        errNum+=1
        pLog(vl,1, 'ERROR Nr = %d' % errNum)

def copyConf(cDir,source):
    '''
Kopiowanie jeśli nie ma do cDir, z dodaniem do nazwy namePrefix
source ma być w katalgu conf
'''
    global errNum
    srcConf=os.path.join('conf', source)
    binFile=0
    dstConf= os.path.join(cDir,'conf',source)
    if os.path.exists(srcConf):

        if not os.path.exists(dstConf):
            binFile=1
            pLog(vl,1, 'nie ma  %s, wkopiuję' % dstConf)
            try:
                shutil.copy(srcConf,dstConf)
            except:
                pLog(vl,1, 'ERROR -nie udało się skopiować %s' % srcConf)
                errNum+=1
                pLog(vl,1, 'ERROR Nr = %d' % errNum)
            else:
                pLog(vl,1, 'skopiowałem %s' % srcConf)
        else:
            pLog(vl,1, 'plik docelowy %s istnieje, nie trzeba kopiować' % srcConf)

    else:
        if os.path.exists(dstConf):
            pLog(vl,1, 'plik docelowy %s istnieje, nie trzeba kopiować' % srcConf)
        else:
            
            pLog(vl,1, 'ERROR - brak pliku źródłowego %s i docelowego' % srcConf)
            errNum+=100
            pLog(vl,1, 'ERROR Nr = %d' % errNum)



def copyConfSD(srcConf,dstConf):
    '''
Kopiowanie pliku bez nadpisywania
'''
    global errNum
    binFile=0
    if os.path.exists(srcConf):

        if not os.path.exists(dstConf):
            binFile=1
            pLog(vl,1, 'nie ma  %s, wkopiuję' % dstConf)
            try:
                shutil.copy(srcConf,dstConf)
            except:
                pLog(vl,1, 'ERROR -nie udało się skopiować %s' % srcConf)
                errNum+=1
                pLog(vl,1, 'ERROR Nr = %d' % errNum)
            else:
                pLog(vl,1, 'skopiowałem %s' % srcConf)
        else:
            pLog(vl,1, 'jest %s, nie trzeba kopiować' % dstConf)
    else:
        if os.path.exists(dstConf):
            pLog(vl,1, 'plik docelowy %s isnieje, nie trzeba kopiować' % srcConf)
        else:
            
            pLog(vl,1, 'ERROR - brak pliku źródłowego %s i docelowego' % srcConf)
            errNum+=100
            pLog(vl,1, 'ERROR Nr = %d' % errNum)


def copyFile(source,target):
    global errNum
    binFile=0
    if os.path.exists(source):
        pLog(vl,1, 'jest plik zrodlowy, moge kopiowac')
        if not os.path.exists(target) == 1:
            pLog(vl,1, 'nie ma  %s, wkopiuję' % target)
        else:
            pLog(vl,1, 'jest  %s,nadpiszę i wkopiuję' % target)
            
        try:
            shutil.copy(source,target)
        except:
            e = sys.exc_info()[0]
            pLog(vl,1, 'ERROR -nie udało się skopiować %s blad systemu $s' % (source,e))
            errNum+=1
            pLog(vl,1, 'ERROR Nr = %d' % errNum)
        else:
            pLog(vl,1, 'skopiowałem %s' % source)

    else:
        pLog(vl,1, 'ERROR - brak pliku źródłowego %s' % source)
        errNum+=1
        pLog(vl,1, 'ERROR Nr = %d' % errNum)
pLog(vl,1,"funkcje wczytane")

licens='''











Licencja ISC (ISCL)

Prawo autorskie (c) 2010-2014. Leszek Loboda - Zakład Elektroniczny Letronik.

Uprawnienie do używania, kopiowania, modyfikowania i / lub rozpowszechniania tego programu w dowolnym celu, 
z lub bez opłat zostaje przyznany, pod warunkiem, że powyższe informacje o prawach autorskich i niniejsze 
pozwolenie pojawią się na wszystkich kopiach. 
OPROGRAMOWANIE JEST DOSTARCZANE "TAK JAK JEST" I AUTOR NIE UDZIELA ŻADNYCH GWARANCJI W ODNIESIENIU DO 
TEGO OPROGRAMOWANIA, W TYM DOMYŚLNYCH GWARANCJI PRZYDATNOŚCI HANDLOWEJ I ZDATNOŚCI. 
W ŻADNYM WYPADKU AUTOR NIE PONOSI ODPOWIEDZIALNOŚCI ZA ŻADNE SZCZEGÓLNE, BEZPOŚREDNIE, 
POŚREDNIE LUB WTÓRNE LUB JAKIEKOLWIEK SZKODY, W TYM WYNIKAJĄCE Z UTRATY DANYCH LUB ZYSKÓW, 
CZY TO W RAMACH UMOWY, ZANIEDBANIA LUB INNYCH CZYNÓW NIEDOZWOLONYCH , WYNIKAJĄCE Z / LUB W ZWIĄZKU 
Z UŻYCIEM /LUB DZIAŁANIEM TEGO OPROGRAMOWANIA.

ISC License (ISCL)

Copyright (c) 2010-2014. Leszek Loboda - Zakład Elektroniczny Letronik.

Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee 
is hereby granted, provided that the above copyright notice and this permission notice appear in all copies.
THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. 
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, 
OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, 
DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, 
ARISING OUT OF OR IN CONNECTION WITH THE USE
'''
print "Zapoznaj się z licencją i akceptuj, jeśli chcesz zainstalować program"
print licens
if yesNo('Czy akceptujesz licencję')=='no':
     print 'Brak akceptacji licencji - instalacja przerwana'
     sys.exit(1)

#------------tworzenie katlogów-------\
#katalog /opt/zeletronik
x="/opt/zeletronik"
pLog(vl,1,'Tworzenie katalogu głównego aplikacji - '+x)
pLog(vl,1,str(createDir(x)+'\n'))


x="/opt/zeletronik/ramdisk"
pLog(vl,1,'Tworzenie  punkty montowania głównego ramdysku aplikacji - '+x)
pLog(vl,1,str(createDir(x)+'\n'))

pLog(vl,1,str(createDir(binDir)+'\n'))
pLog(vl,1,str(createDir(confDir)+'\n'))


n=0

for namePrefixx in counterList:
    namePrefix=namePrefixx.strip()
    n+=1
    '''
    boxType = config[namePrefix].split(',')
    countBox = boxType[0]
    procesBox = boxType[1]'''
    

    pLog(vl,1,'-------------licznik nr %d: %s' %(n,namePrefix))
    cDir=os.path.join(countDir,namePrefix)
    pLog(vl,1,'cDir =' + cDir+'\n')

    dirList=[\
    os.path.join(cDir) \
    ,os.path.join(cDir,'conf') \
    ,os.path.join(cDir,'reports') \
    ,os.path.join(cDir,'reports','minutes') \
    ,os.path.join(cDir,'reports','zip')\
    ,os.path.join(cDir,'reports','tx8')\
    ,os.path.join(cDir,'log')\
    ,os.path.join(cDir,'trash')\
    ,os.path.join(cDir,'trash','minutes')\
    ,os.path.join(cDir,'trash','tx8')\
    ,os.path.join(cDir,'trash','zip')\
    ]

    for x in dirList:
        pLog(vl,1,'Tworzenie katalogu - '+x)
        pLog(vl,1,str(createDir(x)+'\n'))          
    #-------------kopiowanie konfiguracji--------------

    confName=namePrefix+'_lsc.conf'
    pLog(vl,1,'Kopiowanie konfiguracji - '+confName)
    copyConf(cDir,confName)
    pLog(vl,1,'-------------koniec licznika nr %d: %s' %(n,namePrefix))
      
    #------------ramdisk
    ramdiskPath=os.path.join(countDir,'ramdisk')
    cRamdisk=os.path.join(ramdiskPath,namePrefix)
    cRamdiskLink=os.path.join(cDir,'ramdisk')
    pLog(vl,1, 'cRamdisk = %s,ramdiskLink=%s' % (cRamdisk, cRamdiskLink))
    pLog(vl,1, " createDirInfo = %s" % createDir(cRamdisk))
    out=createLink(cRamdisk, cRamdiskLink)
    pLog(vl,1,"createLinkInfo = %s" % str(out))

    
#---------instalacja, uaktualnienie bin
'''
binString="lscCounter.py lscBase.py  lscDR.py  lscGFile.py  lscGlue.py  lscIn.py lscCtsInt64 lscCtsRpi"\
           +" lscLib.py  lscMR.py  lscToFtp.py  lscTx8Txt.py lscStart.py lscStart1.py lscShortLog.py"\
           +" lscRs232Int64  lscRs232Rpi ver.txt lscTel232.py lscTel485.py ntplib.py mTL.py gfdbView.py joinDat.py"\
           + " lscCtsPy.py"'''
binString="lscCounter.py  lscGpio.py lscGlue.py"\
           +" lscLib.py    lscToFtp2.py   lscStart.py lscStart1.py lscShortLog.py"\
           +"  ver.txt   joinDat.py"\
           + " "
binList=binString.split()
print binList

for x in binList:
    copyLib(x)
#kopiowanie install.conf, w którym są informacje o ścieżkach i licznikach
copyConfSD('conf/install.conf',os.path.join(confDir,'install.conf')   )
#copyConfSD('conf/mT.conf',os.path.join(confDir,'mT.conf')   )
#copyConfSD('bin/lvCf.py',os.path.join(countDir,'bin','lvCf.py')   )
#istalacja głównego ramdysku
# tmpfs /opt/zeletronik/ramdisk tmpfs size=512M,nr_inodes=10k,mode=1777 0 0 #ver - 2.25.00
####tworzenie wpisu dla ramdisk w fstab
print '''











Nasz program wykorzystuje ramdisk.

Czy chcesz, aby instalator dodał do pliku /etc/fstab odowieni wpis
i stworzył odpowienie katalogi i łącza?
Jeśli nie wiesz, musisz odpowiedzieć yes
Radisk powstanie przy ponownym uruchomieniu komputera.
'''
if yesNo('Stworzyć ramdisk')== 'yes':


     ramDiskRpi='tmpfs /opt/zeletronik/ramdisk tmpfs nodev,nosuid,size=16M 0 0 # ver - %s' % __version__   
     ramDiskIntel='tmpfs /opt/zeletronik/ramdisk tmpfs size=512M,nr_inodes=10k,mode=1777 0 0 #ver - %s' % __version__ 
     fstabName='/etc/fstab'
     if arch=='Rpi':
           
          L=[['/opt/zeletronik/ramdisk',ramDiskRpi,0]]
          pLog(vl,1, ' fstab line = %s' % L)
          pLog(vl,1,"replaceLine return %s" % replaceLine(fstabName,L))
          pLog(vl,1, ' montowanie ramdisk %s'% str(callCommandArg('mount','/opt/zeletronik/ramdisk')))
          
          

               
     if arch=='Int' or arch=='Int64':
          L=[['/opt/zeletronik/ramdisk',ramDiskIntel,0]]
          pLog(vl,1, ' fstab line %s' % L)
          pLog(vl,1,"replaceLine return %s" % replaceLine(fstabName,L))
          pLog(vl,1, ' montowanie ramdisk %s'% str(callCommandArg('mount','/opt/zeletronik/ramdisk')))
'''
     cRamdiskLink=os.path.join(cDir,'ramdisk')
     pLog(vl,1, 'cRamdisk = %s,ramdiskLink=%s' % (cRamdisk, cRamdiskLink))
     pLog(vl,1, " createDirInfo = %s" % createDir(cRamdisk))
     out=createLink(cRamdisk, cRamdiskLink)
     pLog(vl,1,"createLinkInfo = %s" % str(out))
     errNum+=out[0]
     pLog(vl,1,"errNum = %d" % errNum)
'''



#################edycja crontab
startPath=os.path.join(binDir,'lscStart.py')
cronLine='* * * * *     %s   #version - %s' % (startPath,__version__)
cronLine1='* * * * *       /root/zeletronik/lscUpgrade.py #version - %s'% __version__
#pLog(vl,1,cronLine1)
print '''










Nasz program jest cyklicznie co minutę uruchamiany przez serwis systemowy Linux o nazwie cron.
Do współpracy z naszym programem trzeba go odpowienio skonfigurować.
Trzeba dodać odpowiedni wpis do tablicy crontab:
%s
Możesz to zrobić ręcznie jak potrafisz, albo zlecić to teraz instalatorowi.
Instalator może też wstawić zablokowaną przy pomocy # linię, którą odblokujesz ręcznie później.
''' % cronLine
if yesNo("\n\n\nczy chcesz, żeby instalator automatycznie dodał odpwiedni wpis do crontab? - jeśli nie wiesz, musisz wybrać 'yes' ")=='yes':

     pLog(vl,1,cronLine)
     if yesNo("\n\n\nCzy zablokować tymczasowo nową linie crontab przy pomocy # - jeśli nie wiesz, wybiesz 'no'")=='yes':
          cronLine='#'+cronLine


     L=[[startPath,cronLine,0]]#,['lscUpgrade.py',cronLine1,0]]
     pLog(vl,1,"L = %s" % str(L))
     if arch=='Prx':
          cronFile='/etc/crontabs/root'
     if arch=='Int' or arch=='Int64' or arch=='Rpi':
          cronFile='/var/spool/cron/crontabs/root'
     pLog(vl,1,"replaceLine(%s,%s)" % (cronFile,str(L)))
     pLog(vl,1,"replaceLine return %s" % replaceLine(cronFile,L))


pLog(vl,1,"errNum = %d" % errNum)


returnErr=None
if errNum >0 and errNum != 100:
    pLog(vl,0,'\n\n\nERROR ILOŚĆ BŁĘDÓW = %d' % errNum)
    returnErr=1
else:
    if errNum == 100:
        pLog(vl,0,'**************** SUCCESS-LSC ************ nie ma błędów tylko brak configuracji')
    else:
        
        pLog(vl,0,'****************SUCCESS-LSC ************ nie ma błędów')

os.system('sync')     


#--------------konczenie------
flog.close()
